import json
import re
import subprocess
import cv2
import os


def show(image):
    cv2.imshow("image", image)
    cv2.waitKey(0)


def ocr_name(input_image, set):
    top_y = 648
    bottom_y = 660
    left_x = 20
    right_x = 49
    crop_mci = input_image[top_y:bottom_y, left_x:right_x]

    #show(crop_mci)

    ##gray_image = cv2.cvtColor(crop_mci, cv2.COLOR_BGR2GRAY)
    ##ret, threshold = cv2.threshold(gray_image,64,255,cv2.THRESH_BINARY_INV)
    cv2.imwrite('mci.png', crop_mci)

    ## -psm (page segmentation mode) 8 - Treat the image as a single word.
    subprocess.call('tesseract -psm 8 mci.png mci nobatch digits'.split(' '))

    with open('mci.txt', 'r') as mci:
        mci_str = re.sub(r'[^0-9]*', '', mci.read(), flags=re.MULTILINE)
        mci_num = int(mci_str)

    os.unlink('mci.txt')
    os.unlink('mci.png')

    with open(set + '.json', 'r') as set_json_file:
        set_json = json.load(set_json_file)

    try:
        return mci_str + ' :: ' + set_json['cards'][mci_num-1]['name']
    except:
        return mci_str
